"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const binder_base_1 = require("./binder-base");
const value_converter_1 = require("./value-converter");
class DecoratorBinder extends binder_base_1.BinderBase {
    bind(routeInfo, parameterName, request) {
        let decorators = routeInfo.methodMetaData.parameters.filter(x => x.name == parameterName)[0].decorators;
        if (!decorators)
            return this.next();
        let decorator = decorators.filter(x => x.name == "body" || x.name == "cookie")[0];
        if (!decorator)
            return this.next();
        if (decorator.name == "cookie") {
            let value = value_converter_1.convert(routeInfo, parameterName, this.extractCookie(request, decorator));
            return this.exit(value);
        }
        else {
            return this.exit(request.body);
        }
    }
    extractCookie(request, decorator) {
        if (!decorator.parameters || decorator.parameters.length == 0) {
            return request.cookies;
        }
        else {
            let name = decorator.parameters[0].value;
            return request.getCookie(name);
        }
    }
}
exports.DecoratorBinder = DecoratorBinder;
