"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const binder_base_1 = require("./binder-base");
const resolver_1 = require("../resolver");
class ValTypeBinder extends binder_base_1.BinderBase {
    constructor(pathResolver) {
        super();
        this.pathResolver = pathResolver;
    }
    bind(routeInfo, parameterName, request) {
        if (routeInfo.methodMetaData.parameters.some(x => x.decorators != undefined
            && x.decorators.some(d => d.name == "body")))
            return this.next();
        let decorators = routeInfo.methodMetaData
            .parameters.filter(x => x.name == parameterName)[0].decorators;
        if (decorators == undefined || decorators.length == 0 || !decorators.some(x => x.name == "type"))
            return this.next();
        let typeDecorator = decorators.filter(x => x.name == "type")[0].parameters[0];
        if (!new resolver_1.QualifiedName(typeDecorator.value, this.pathResolver).isValid())
            return this.next();
        return this.exit(request.body);
    }
}
exports.ValTypeBinder = ValTypeBinder;
