"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const base_converter_1 = require("./base-converter");
const router_1 = require("../../router");
class ConventionValueConverter extends base_converter_1.BaseConverter {
    convert(meta, value) {
        if (typeof value == "undefined" || value == null)
            return this.exit(value);
        if (meta.name.indexOf("s") == 0 && this.isUppercase(meta.name[1]))
            return this.toString(value, meta);
        if ((meta.name.indexOf("i") == 0 || meta.name.indexOf("n") == 0) &&
            this.isUppercase(meta.name[1]))
            return this.toNumber(value, meta);
        if (meta.name.indexOf("b") == 0 && this.isUppercase(meta.name[1]))
            return this.toBoolean(value, meta);
        return this.next();
    }
    isUppercase(char) {
        return char && char == char.toUpperCase();
    }
    toString(value, meta) {
        if (typeof value == "object")
            throw new Error(`Expected parameter type of 'string'  but got object in [${meta.name}] ${router_1.getRouteDetail(this.routeInfo)}`);
        return this.exit(value.toString());
    }
    toNumber(value, meta) {
        if (typeof value == "object")
            throw new Error(`Expected parameter type of 'number'  but got object in [${meta.name}] ${router_1.getRouteDetail(this.routeInfo)}`);
        return this.exit(parseInt(value));
    }
    toBoolean(value, meta) {
        if (typeof value == "object")
            throw new Error(`Expected parameter type of 'boolean'  but got object in [${meta.name}] ${router_1.getRouteDetail(this.routeInfo)}`);
        return this.exit(value.toLowerCase() === "true");
    }
}
exports.ConventionValueConverter = ConventionValueConverter;
