"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const decorated_value_converter_1 = require("./decorated-value-converter");
const default_value_converter_1 = require("./default-value-converter");
const convention_value_converter_1 = require("./convention-value-converter");
function convert(routeInfo, name, value) {
    const Converters = [
        new decorated_value_converter_1.DecoratedValueConverter(routeInfo),
        new convention_value_converter_1.ConventionValueConverter(routeInfo),
        new default_value_converter_1.DefaultValueConverter(routeInfo)
    ];
    for (let converter of Converters) {
        let result = converter.convert(routeInfo.methodMetaData.parameters.filter(x => x.name == name)[0], value);
        if (result.type == "Exit")
            return result.result;
    }
}
exports.convert = convert;
tslib_1.__exportStar(require("./auto-converter"), exports);
