"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const decorator_1 = require("../../decorator");
exports.MiddlewareMetadataKey = "kamboja:middleware";
exports.MiddlewareIdMetadataKey = "kamboja:middleware:id";
class MiddlewareDecorator {
    use(middleware) {
        return (...args) => {
            decorator_1.DecoratorHelper.save(exports.MiddlewareMetadataKey, middleware, args);
        };
    }
    id(id) {
        return (...args) => {
            decorator_1.DecoratorHelper.save(exports.MiddlewareIdMetadataKey, id, args);
        };
    }
    static getId(target) {
        let result = decorator_1.DecoratorHelper.get(exports.MiddlewareIdMetadataKey, target);
        return result ? result[0] : undefined;
    }
    static getMiddlewares(target, methodName) {
        return decorator_1.DecoratorHelper.get(exports.MiddlewareMetadataKey, target, methodName);
    }
}
exports.MiddlewareDecorator = MiddlewareDecorator;
exports.middleware = new MiddlewareDecorator();
