"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const framework_1 = require("../../framework");
var MiddlewareFactory;
(function (MiddlewareFactory) {
    function resolve(middlewares, resolver) {
        let result = [];
        if (!middlewares)
            return result;
        for (let middleware of middlewares) {
            if (typeof middleware == "string") {
                try {
                    let instance = resolver.resolve(middleware);
                    result.push(instance);
                }
                catch (e) {
                    throw new Error(`Can not instantiate middleware [${middleware}] in global middlewares`);
                }
            }
            else if (typeof middleware == "function") {
                result.push(new framework_1.CallbackMiddleware(middleware));
            }
            else {
                result.push(middleware);
            }
        }
        return result;
    }
    MiddlewareFactory.resolve = resolve;
})(MiddlewareFactory = exports.MiddlewareFactory || (exports.MiddlewareFactory = {}));
