"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const kamboja_core_1 = require("kamboja-core");
class AttachableInvocation extends kamboja_core_1.Invocation {
    constructor(middlewares, controllerInfo, facade) {
        super();
        this.middlewares = middlewares;
        this.controllerInfo = controllerInfo;
        this.facade = facade;
    }
    attach(invocation) {
        invocation.controllerInfo = this.controllerInfo;
        invocation.middlewares = this.middlewares;
        invocation.facade = this.facade;
        this.invocation = invocation;
    }
    proceed() {
        this.invocation.context = this.context;
        this.invocation.parameters = this.parameters;
        return this.invocation.proceed();
    }
}
exports.AttachableInvocation = AttachableInvocation;
