"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Chalk = require("chalk");
class Logger {
    constructor(type) {
        this.type = type;
    }
    log(type, message) {
        let chalk;
        let prefix = "";
        switch (type) {
            case "Error":
                prefix = "Error: ";
                chalk = Chalk.red;
                break;
            case "Warning":
                prefix = "Warning: ";
                chalk = Chalk.yellow;
                break;
            default:
                chalk = (msg) => msg;
                break;
        }
        console.log(chalk(Chalk.bold("  [Kamboja] ")) + chalk(prefix + message));
        return this;
    }
    info(message) {
        if (this.type == "Info")
            return this.log("Info", message);
        else
            return this;
    }
    error(message) {
        if (this.type == "Info" || this.type == "Warning" || this.type == "Error")
            return this.log("Error", message);
        else
            return this;
    }
    warning(message) {
        if (this.type == "Info" || this.type == "Warning")
            return this.log("Warning", message);
        else
            return this;
    }
    newLine() {
        if (this.type == "Info" || this.type == "Warning" || this.type == "Error")
            console.log();
        return this;
    }
}
exports.Logger = Logger;
