"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const qualified_name_1 = require("./qualified-name");
class DefaultDependencyResolver {
    constructor(idResolver, pathResolver) {
        this.idResolver = idResolver;
        this.pathResolver = pathResolver;
    }
    resolve(id) {
        let name = this.idResolver.getClassName(id);
        let qualified = new qualified_name_1.QualifiedName(name, this.pathResolver);
        let instance = require(this.pathResolver.resolve(qualified.fileName));
        let classParts = qualified.className.split(".");
        classParts.forEach(x => instance = instance[x.trim()]);
        return new instance();
    }
}
exports.DefaultDependencyResolver = DefaultDependencyResolver;
