"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Path = require("path");
class DefaultPathResolver {
    constructor(rootPath) {
        this.rootPath = rootPath;
    }
    /**
     * Resolve path from relative to absolute
     */
    resolve(path) {
        return Path.join(this.rootPath, path);
    }
    /**
     * Convert absolute path to relative to this.rootPath
     */
    relative(absolute) {
        return Path.relative(this.rootPath, absolute);
    }
    /**
     * Normalize path to qualified name path
     */
    normalize(path) {
        if (Path.isAbsolute(path)) {
            path = this.relative(path);
        }
        let raw = Path.parse(path);
        return Path.join(raw.dir, raw.name);
    }
}
exports.DefaultPathResolver = DefaultPathResolver;
