"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const kamboja_core_1 = require("kamboja-core");
class ClassNotInherritedFromControllerAnalyzer {
    analyse(route) {
        if (route.analysis && route.analysis.some(x => x == kamboja_core_1.RouteAnalysisCode.ClassNotInheritedFromController)) {
            return [{
                    code: kamboja_core_1.RouteAnalysisCode.ClassNotInheritedFromController,
                    type: "Warning",
                    message: `Class not inherited from Controller, ApiController or SocketController in [${route.qualifiedClassName}]`
                }];
        }
    }
}
exports.ClassNotInherritedFromControllerAnalyzer = ClassNotInherritedFromControllerAnalyzer;
