"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const kamboja_core_1 = require("kamboja-core");
const helper_1 = require("../helper");
class ConflictInternalDecoratorAnalyzer {
    analyse(route) {
        if (route.analysis && route.analysis.some(x => x == kamboja_core_1.RouteAnalysisCode.ConflictDecorators)) {
            return [{
                    code: kamboja_core_1.RouteAnalysisCode.ConflictDecorators,
                    type: "Error",
                    message: `Route conflict, @route.ignore() can't be combined with other type of routes in ${helper_1.getRouteDetail(route)}`
                }];
        }
    }
}
exports.ConflictInternalDecoratorAnalyzer = ConflictInternalDecoratorAnalyzer;
