"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const kamboja_core_1 = require("kamboja-core");
const helper_1 = require("../helper");
class DuplicateRouteAnalyzer {
    constructor() {
        this.routes = [];
    }
    analyse(route) {
        if (!route.route)
            return;
        let dupe = this.routes.filter(x => x.route.toLowerCase() == route.route.toLowerCase()
            && route.httpMethod == x.httpMethod);
        if (dupe.length > 0) {
            return [{
                    code: kamboja_core_1.RouteAnalysisCode.DuplicateRoutes,
                    message: `Duplicate route [${route.route}] on: \n  ${helper_1.getRouteDetail(route)} \n\  ${helper_1.getRouteDetail(dupe[0])}`,
                    type: "Error"
                }];
        }
        else {
            this.routes.push(route);
            return;
        }
    }
}
exports.DuplicateRouteAnalyzer = DuplicateRouteAnalyzer;
