"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const kamboja_core_1 = require("kamboja-core");
const helper_1 = require("../helper");
class EventWithQueryParameters {
    constructor() {
        this.routes = [];
    }
    analyse(route) {
        if (route.analysis && route.analysis.some(x => x == kamboja_core_1.RouteAnalysisCode.QueryParameterNotAllowed)) {
            let routeParams = route.route.split("/")
                .filter(x => x.charAt(0) == ":")
                .map(x => x.substring(1));
            return [{
                    code: kamboja_core_1.RouteAnalysisCode.QueryParameterNotAllowed,
                    type: "Error",
                    message: `Query parameters in @route.on() is not allowed in ${helper_1.getRouteDetail(route)}`
                }];
        }
    }
}
exports.EventWithQueryParameters = EventWithQueryParameters;
