"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const kamboja_core_1 = require("kamboja-core");
const helper_1 = require("../helper");
class MissingActionParameterAnalyzer {
    analyse(route) {
        if (route.analysis && route.analysis.some(x => x == kamboja_core_1.RouteAnalysisCode.MissingActionParameters)) {
            let routeParams = route.route.split("/")
                .filter(x => x.charAt(0) == ":")
                .map(x => x.substring(1));
            return [{
                    code: kamboja_core_1.RouteAnalysisCode.MissingActionParameters,
                    type: "Warning",
                    message: `Parameters [${routeParams.join(", ")}] in [${route.route}] doesn't have associated parameters in ${helper_1.getRouteDetail(route)}`
                }];
        }
    }
}
exports.MissingActionParameterAnalyzer = MissingActionParameterAnalyzer;
