"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const kamboja_core_1 = require("kamboja-core");
const helper_1 = require("../helper");
class MissingRouteParameterAnalyzer {
    analyse(route) {
        if (route.analysis && route.analysis.some(x => x == kamboja_core_1.RouteAnalysisCode.MissingRouteParameters)) {
            let actionParams = route.methodMetaData
                .parameters.map(x => x.name);
            return [{
                    code: kamboja_core_1.RouteAnalysisCode.MissingRouteParameters,
                    type: "Warning",
                    message: `Parameters [${actionParams.join(", ")}] in ${helper_1.getRouteDetail(route)} doesn't have associated parameters in [${route.route}]`
                }];
        }
    }
}
exports.MissingRouteParameterAnalyzer = MissingRouteParameterAnalyzer;
