"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const kamboja_core_1 = require("kamboja-core");
const helper_1 = require("../helper");
class UnassociatedParameterAnalyzer {
    analyse(route) {
        if (route.analysis && route.analysis.some(x => x == kamboja_core_1.RouteAnalysisCode.UnAssociatedParameters)) {
            let routeParams = route.route.split("/")
                .filter(x => x.charAt(0) == ":")
                .map(x => x.substring(1));
            let actionParams = route.methodMetaData
                .parameters.map(x => x.name);
            let missing = actionParams.filter(x => !routeParams.some(y => x == y));
            if (missing.length > 0) {
                return [{
                        code: kamboja_core_1.RouteAnalysisCode.UnAssociatedParameters,
                        type: "Warning",
                        message: `Parameters [${missing.join(", ")}] in ${helper_1.getRouteDetail(route)} doesn't have associated parameters in [${route.route}]`
                    }];
            }
        }
    }
}
exports.UnassociatedParameterAnalyzer = UnassociatedParameterAnalyzer;
