"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const kamboja_core_1 = require("kamboja-core");
const helper_1 = require("../helper");
const reservedWords = [
    "context", "validator"
];
const apiReservedWords = [
    "context", "validator"
];
class ReservedWordUsedAnalyzer {
    analyse(route) {
        let usedInController = reservedWords.some(x => route.methodMetaData
            && x == route.methodMetaData.name)
            && route.classMetaData.baseClass == "Controller";
        let usedInApiController = apiReservedWords.some(x => route.methodMetaData
            && x == route.methodMetaData.name)
            && route.classMetaData.baseClass == "ApiController";
        if (usedInApiController || usedInController) {
            return [{
                    code: kamboja_core_1.RouteAnalysisCode.UnAssociatedParameters,
                    type: "Error",
                    message: `[${route.methodMetaData.name}] must not be used as action, because it will override the Controller method, in ${helper_1.getRouteDetail(route)}`
                }];
        }
    }
}
exports.ReservedWordUsedAnalyzer = ReservedWordUsedAnalyzer;
