"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Transformer = require("./transformers");
class RouteGenerator {
    constructor(idResolver, metaData) {
        this.idResolver = idResolver;
        this.metaData = metaData;
    }
    getRoutes() {
        let routes = [];
        for (let file of this.metaData) {
            let route = Transformer.transform(file);
            route.forEach(x => {
                x.classId = this.idResolver.getClassId(x.qualifiedClassName);
                routes.push(x);
            });
        }
        return routes;
    }
}
exports.RouteGenerator = RouteGenerator;
