"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const Kecubung = require("kecubung");
const Core = require("kamboja-core");
const transformer_base_1 = require("./transformer-base");
class DefaultActionTransformer extends transformer_base_1.TransformerBase {
    transform(method, parent, prevResult) {
        let path = "/" + method.name.toLowerCase();
        /* method.parameters.forEach(x => {
            path += `/:${x.name}`
        }) */
        if (prevResult) {
            prevResult.forEach(x => {
                if (Kecubung.flag(x.overrideRequest, Core.OverrideRequest.Route)) {
                    x.route = parent + path;
                    x.methodPath = path;
                }
                x.collaborator = [];
                x.collaborator.push("DefaultAction");
            });
            return this.exit(prevResult);
        }
        else {
            return this.exit([{
                    initiator: "DefaultAction",
                    route: parent + path,
                    httpMethod: "GET",
                    methodMetaData: method,
                    methodPath: path
                }]);
        }
    }
}
tslib_1.__decorate([
    transformer_base_1.when("Method")
], DefaultActionTransformer.prototype, "transform", null);
exports.DefaultActionTransformer = DefaultActionTransformer;
