"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const transformer_base_1 = require("./transformer-base");
const controller_1 = require("./controller");
const module_1 = require("./module");
const controller_decorator_1 = require("./controller-decorator");
class FileTransformer extends transformer_base_1.TransformerBase {
    transform(meta, parent, prevResult) {
        this.installChildTransformer();
        let result = this.transformChildren(meta.children, parent);
        result.forEach(x => x.qualifiedClassName += `, ${meta.name}`);
        return this.exit(result);
    }
    installChildTransformer() {
        //highest priority transformer should stay on top of another
        this.transformers = [
            new module_1.ModuleTransformer(),
            new controller_decorator_1.ControllerWithDecorator(),
            new controller_1.ControllerTransformer(),
        ];
    }
}
tslib_1.__decorate([
    transformer_base_1.when("File")
], FileTransformer.prototype, "transform", null);
exports.FileTransformer = FileTransformer;
