"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const transformer_base_1 = require("./transformer-base");
class IndexActionTransformer extends transformer_base_1.TransformerBase {
    transform(method, parent, prevResult) {
        if (prevResult)
            return this.next(prevResult);
        if (method.name.toLowerCase() == "index") {
            method.parameters.forEach(x => {
                parent += `/:${x.name}`;
            });
            return this.exit([{
                    initiator: "IndexAction",
                    route: parent,
                    httpMethod: "GET",
                    methodMetaData: method
                }]);
        }
        else
            return this.next();
    }
}
tslib_1.__decorate([
    transformer_base_1.when("Method")
], IndexActionTransformer.prototype, "transform", null);
exports.IndexActionTransformer = IndexActionTransformer;
