"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const Core = require("kamboja-core");
const transformer_base_1 = require("./transformer-base");
class InternalDecoratorTransformer extends transformer_base_1.TransformerBase {
    constructor() {
        super(...arguments);
        this.decorators = ["get", "put", "post", "delete", "ignore", "patch"];
    }
    transform(meta, parent, prevResult) {
        if (meta.decorators && meta.decorators.length > 0) {
            let decorators = meta.decorators.filter(x => this.decorators.some(y => y == x.name));
            //decorator conflict with internal
            if ((decorators.some(x => x.name == "ignore")
                && decorators.length > 1)) {
                return this.next({
                    analysis: [Core.RouteAnalysisCode.ConflictDecorators],
                    methodMetaData: meta,
                    httpMethod: "GET",
                    initiator: "InternalDecorator"
                });
            }
            for (let decorator of meta.decorators) {
                let name = decorator.name;
                if (name == "ignore")
                    return this.exit();
            }
        }
        return this.next();
    }
}
tslib_1.__decorate([
    transformer_base_1.when("Method")
], InternalDecoratorTransformer.prototype, "transform", null);
exports.InternalDecoratorTransformer = InternalDecoratorTransformer;
