"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const Kecubung = require("kecubung");
const Core = require("kamboja-core");
const transformer_base_1 = require("./transformer-base");
const controller_decorator_1 = require("./controller-decorator");
const controller_1 = require("./controller");
class ModuleTransformer extends transformer_base_1.TransformerBase {
    transform(meta, parent, prevResult) {
        this.installChildTransformer();
        parent += "/" + meta.name.toLowerCase();
        let result = this.transformChildren(meta.children, parent);
        result.forEach(x => {
            if (!Kecubung.flag(meta.analysis, Kecubung.AnalysisType.Valid)) {
                if (!x.analysis)
                    x.analysis = [];
                x.analysis.push(Core.RouteAnalysisCode.ClassNotExported);
            }
            x.qualifiedClassName = meta.name + "." + x.qualifiedClassName;
            if (!x.collaborator)
                x.collaborator = [];
            x.collaborator.push("Module");
        });
        return this.exit(result);
    }
    installChildTransformer() {
        //highest priority transformer should stay on top of another
        this.transformers = [
            new ModuleTransformer(),
            new controller_decorator_1.ControllerWithDecorator(),
            new controller_1.ControllerTransformer(),
        ];
    }
}
tslib_1.__decorate([
    transformer_base_1.when("Module")
], ModuleTransformer.prototype, "transform", null);
exports.ModuleTransformer = ModuleTransformer;
