"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const baseclasses_1 = require("./baseclasses");
const Validator = require("validator");
class EmailValidator extends baseclasses_1.ValidatorBase {
    validate(args) {
        if (this.isEmpty(args.value))
            return;
        if (!Validator.isEmail(args.value.toString())) {
            let argument = args.decoratorArgs[0];
            let customMessage = argument && argument.value;
            return [{
                    field: args.parentField ? `${args.parentField}.${args.field}` : args.field,
                    message: customMessage || `[${args.field}] is not a valid email address`
                }];
        }
    }
}
tslib_1.__decorate([
    baseclasses_1.decoratorName("email")
], EmailValidator.prototype, "validate", null);
exports.EmailValidator = EmailValidator;
