"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const baseclasses_1 = require("./baseclasses");
class RequiredValidator extends baseclasses_1.ValidatorBase {
    validate(args) {
        if (this.isEmpty(args.value)) {
            let decoratorArg = args.decoratorArgs[0];
            let customMessage = decoratorArg && decoratorArg.value;
            return [{
                    field: args.parentField ? `${args.parentField}.${args.field}` : args.field,
                    message: customMessage || `[${args.field}] is required`
                }];
        }
    }
}
tslib_1.__decorate([
    baseclasses_1.decoratorName("required")
], RequiredValidator.prototype, "validate", null);
exports.RequiredValidator = RequiredValidator;
