"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var ValidatorFactory;
(function (ValidatorFactory) {
    function resolve(commands, resolver) {
        let validators = [];
        commands.forEach(x => {
            if (typeof x == "string") {
                try {
                    let validator = resolver.resolve(x);
                    validators.push(validator);
                }
                catch (e) {
                    throw new Error(`Can not instantiate custom validator [${x}]`);
                }
            }
            else
                validators.push(x);
        });
        return validators;
    }
    ValidatorFactory.resolve = resolve;
})(ValidatorFactory = exports.ValidatorFactory || (exports.ValidatorFactory = {}));
